Subject: Re: [PATCH] HID: wiimote: Select INPUT_FF_MEMLESS

From: Sean Young <[email-masked]>
Date: Thu, 8 Dec 2011 22:43:23 +0000

On Thu, Dec 08, 2011 at 11:23:26AM -0500, [email-masked] wrote:
> 
> >> I don't mean to be a complainer, but shouldn't the WiiMote module depend
> >> on FF_MEMLESS rather than just forcing it on.
> > > > I have considered that but "grep -r FF_MEMLESS" returned no other
> > driver using "depend" so I decided to use "select", too.
> 
> If you look at 'Kconfig' every other driver is fragmented into a 'driver'
> and 'driver_ff', it is only the 'driver_ff' bit which does the
> force-feedback and all the 'drivers' would appear to work OK (as pure
> input devices) with FF disabled.

Which also requires these drivers to have #ifdef's in their code, they
would be much cleaner without those.

> Someone here will be able to comment whether that is policy, convention or
> just historic....
> 
> >> Some people might not want FF_MEMLESS enabled.
> >
> > Why? It is a really small feature that depends only on CONFIG_INPUT.
> > Just 600 lines of code. I don't see why someone who wants to enable
> > the way bigger wiimote driver and HID core would bother about
> > FF_MEMLESS? Why should someone want to disable the rumble-feature of
> > the wiimote?
> 
> 600 lines where? What's the other costs to the system when enabling the FF
> code in the kernel.

There is just ff-memless.c which will be compiled into a module (unless 
not configured to so of of course), which is less than 600 lines including 
comments. Nothing else changes.

The fact that these drivers can be built without force feedback enabled 
is an analomy. If every feature a piece of hardware provides were 
configurable with #ifdef's, the code would not be very maintainable.

> > I cannot see any real use-case here. Maybe you can explain a bit more.
> 
> Again I'm not here to kick up a fuss; it just looked different from the
> norm, so I was flagging it.

I guess once upon time people considered force feedback not useful enough
to compile in.

I'm hoping that patches for removing the CONFIG_*_FF #ifdefs would be 
accepted.

Sean